from __future__ import with_statement
print "b124"
os.chdir("/Users/was/talks/2007-01-15-sage-cse/sage_notebook/worksheets/_scratch_/cells/282")
__SAGE_t__=cputime()
__SAGE_w__=walltime()


all
#auto

# The source code to draw factorization trees...

import random

def factor_tree(n, font=Integer(10)):
    rows = []
    v = [(n,None,Integer(0))]
    ftree(rows, v, Integer(0), factor(n))
    return draw_ftree(rows, font)

def ftree(rows, v, i, F):
    if len(v) > Integer(0):
        # add a row to g at the ith level.
        rows.append(v)
    w = []
    for i in range(len(v)):
        k, _,_ = v[i]
        if k is None or is_prime(k):
            w.append((None,None,None))
        else:
            d = random.choice(divisors(k)[Integer(1):-Integer(1)])
            w.append((d,k,i))
            e = k//d
            if e == Integer(1):
                w.append((None,None))
            else:
                w.append((e,k,i))
    if len(w) > len(v):
        ftree(rows, w, i+Integer(1), F)


def draw_ftree(rows,font):
    g = Graphics()
    for i in range(len(rows)):
        cur = rows[i]
        for j in range(len(cur)):
            e, f, k = cur[j]
            if not e is None:
                if is_prime(e):
                     c = (Integer(1),Integer(0),Integer(0))
                else:
                     c = (Integer(0),Integer(0),RealNumber('.4'))
                g += text(str(e), (j*Integer(2)-len(cur),-i), fontsize=font, rgbcolor=c)
                if not k is None and not f is None:
                    g += line([(j*Integer(2)-len(cur),-i), (k*Integer(2)-len(rows[i-Integer(1)]),-i+Integer(1))], alpha=RealNumber('0.4'), thickness=Integer(1))
    return g

def factor_trees(n, cols=Integer(4), rows=Integer(3), font=Integer(10)):
    return graphics_array([[factor_tree(n,font) for _ in range(cols)] for _ in range(rows)])
print "CPU time: %.2f s,  Wall time: %.2f s"%(cputime(__SAGE_t__), walltime(__SAGE_w__))
print "\n\nv=%s"%_support_.variables(True)
print "e124"
